#include <stdio.h>
#include "graph.h"

typedef struct memlist_t MEMPTR;
static struct memlist_t{
       char *address;
       MEMPTR *next;
};
static char *ptr;
static char *cur_ptr;
static struct memlist_t *memlist;
static struct memlist_t *cur_list;
static rem_size;
static cal_count;

#define DEBUG


/*======================================================================*/
/* allocate memory for hash table */
void my_alloc_init(size)
int size;
{
  int max_size;
  max_size = 5*sizeof(struct hash_struct)*size;
  ptr      = (char *) malloc(max_size);
  if (!ptr) {
    max_size = 4*sizeof(struct hash_struct)*size;
    ptr      = (char *) malloc(max_size);
    if (!ptr) {
      max_size = 3*sizeof(struct hash_struct)*size;
      ptr      = (char *) malloc(max_size);
    }
  }
  if (!ptr) 
    printf("Not enough memory for HASHTABLE; reduce the initial size \n"), exit(0);

  rem_size         = max_size;
  cur_ptr          = ptr; 
  memlist          = (struct memlist_t *) malloc(sizeof(struct memlist_t));
  cur_list         = memlist;
  memlist->next    = NULL;
  memlist->address = NULL;
}
/*======================================================================*/

char *
my_malloc(cur_size)
int cur_size;
{
  char * ret_ptr;
  char *new_mem;

  if((rem_size-cur_size) < 0) {
    new_mem           = (char *) malloc(cur_size);
    cur_list->address = (char *)new_mem;  
    cur_list->next    = (struct memlist_t *) malloc(sizeof(struct memlist_t));
    cur_list          = cur_list->next;
    cur_list->next    = NULL;
    return (char *) new_mem;
  }   
  else {
    ret_ptr   = cur_ptr;
    cur_ptr  += cur_size;
    rem_size -= cur_size;
    return ret_ptr;
  }
}
/*======================================================================*/

my_free()
{
  struct memlist_t *temp;
  int count=0;

  free(ptr);
  while (memlist->next != NULL) {
    temp = memlist->next;
    free(memlist);
    count++;
    memlist = temp;
  }
/*
  printf("freed %d \n", count);
*/
}
/*======================================================================*/


void
free_hash_table(hstruct)
HASHPTR *hstruct;
{
  int i;
  HASHPTR *next_h, *temp_h;
  LISTPTR *next_l, *temp_l;

  for (i=0; i<SIZE; i++) {
    next_h = hstruct[i].next;
    while (next_h != NULL) {
       temp_h = next_h->next;
       next_l = next_h->next_list;
       while (next_l != NULL) {
         temp_l = next_l->next;
         free(next_l);
         next_l = temp_l;
       }
       free(next_h);
       next_h = temp_h;
    }
  } 
  free(hstruct);
}

/*======================================================================*/
